<?php

include("extensions/EqItems/eqitem.php");
include("extensions/ItemSets/eqitemset.php");

function efItemSetsMessages() {
	return array(
		'en' => array(
		'itemsets' => 'Item Sets'
	), );
}

class itemsets extends SpecialPage {

	var $FORM_TARGET   = "http://www.eqwiki.net/wiki/Special:ItemSets";
	var $limitcount    = 50;
	var $startrow      = 0;

	var $form_setid        = null;
	var $form_action       = null;
	var $form_oldaction    = null;
	var $form_setname      = null;
	var $form_searchtext   = null;
	var $form_startrow     = null;
	var $form_createexists = null;
	var $form_createnew    = null;
	var $form_compareids   = null;

	var $comparesets = array();
	var $itemset     = null;

	/**
	 * Constructor
	 */
	public function __construct() {
		global $wgMessageCache;

		foreach( efItemSetsMessages() as $lang => $messages )
			$wgMessageCache->addMessages( $messages, $lang );

		parent::__construct( 'ItemSets', 'itemsets' );

		$this->itemset = new eqitemset;
	}

	/**
	 * @param $par Parameters passed to the page
	 */
	public function execute( $par ) {
		global $wgUser, $wgRequest, $wgOut, $item_fields;
		$this->setHeaders();
				
			# Keep out blocked users
		if( $wgUser->isBlocked() ) {
			$wgOut->blockedPage();
			return;
		}

		$query = "UPDATE site_stats SET ss_eqitemsets_count = ss_eqitemsets_count + 1";
		mysql_query($query);

		$this->parseQuery();

		if (!$this->checkPermissions($this->form_action)) {
			$wgOut->addHTML("Permission denied!");
			return;
		}

		if ($this->form_action == "new") {
			$this->outputPageLinks();
			$wgOut->addHTML("Create new item set...");
			$this->itemset->isvalid = true;
			$this->outputEditForm();
		}
		else if ($this->form_action == "add") {
			if (!$this->addItemsToSet()) return;
			$this->outputPageLinks();
			$this->outputSetView();
		}
		else if ($this->form_action == "update") {
			$this->saveItemSet();
			$this->outputPageLinks();
			$this->outputSetView();
		}
		else if ($this->form_action == "edit") {
			$this->loadItemSet();
			$this->outputPageLinks();
			$this->outputEditForm();
		}
		else if ($this->form_action == "compare") {
			$this->outputPageLinks();
			$this->compareSets();
		}
		else if ($this->form_action == "delete") {
			$this->loadItemSet();
			$result = $this->deleteItemSet();

			if ($result) {
				$wgOut->addHTML("Deleted item set #". $this->itemset->setid ."!<br/>");
			}
			else {
				$wgOut->addHTML("Error deleting item set!<br/>");
			}

			$this->outputPageLinks();
			$this->outputSetList();
		}
		else if ($this->form_setid) {
			$this->loadItemSet();
			$this->outputPageLinks();
			$this->outputSetView();
		}
		else {
			$this->outputPageLinks();
			$this->outputSetList();
		}
	}

	private function checkPermissions ($action) {
		global $wgUser, $wgOut;

		if ($action == 'new') {
			return $wgUser->isAllowed('eqitemsetcreate');
		}
		else if ($action == 'edit' || $action == 'update' || $action == 'add') {
			return $wgUser->isAllowed('eqitemsetedit');
		}
		else if ($action == 'lock') {
			return $wgUser->isAllowed('eqitemsetlock');
		}
		else if ($action == 'delete') {
			return $wgUser->isAllowed('eqitemsetdelete');
		}

		return true;
	}

	private function compareSets () {
		global $wgOut;

		$this->loadCompareSets();

		if (!$this->itemset->isvalid || count($this->comparesets) < 1) {
			$wgOut->addHTML("No sets to compare!");
			return false;
		}

		$this->computeSetDifferences();

		$wgOut->addHTML("<table border='0' cellpadding='2' cellspacing='0'>");

		$wgOut->addHTML("<tr class='eqsettitle'>");
			$wgOut->addHTML("<th>Comparing Set</th>");
			$wgOut->addHTML("<th>Stats</th>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqseteven'>");
			$wgOut->addHTML("<td><a href='". $this->FORM_TARGET ."?id=". $this->itemset->setid ."'><b>". $this->itemset->setname ."</b></a></td>");
			$wgOut->addHTML("<td><small>");
			$wgOut->addHTML($this->itemset->getStatSummary("\n"));
			$wgOut->addHTML($this->itemset->getHeroicSummary("\n"));
			$wgOut->addHTML($this->itemset->getResistSummary("\n"));
			$wgOut->addHTML($this->itemset->getModSummary("\n"));
			$wgOut->addHTML($this->itemset->getSkillSummary("\n"));
			$wgOut->addHTML($this->itemset->getBardModSummary("\n"));
			$wgOut->addHTML($this->itemset->getExtraDmgSummary("\n"));
			$wgOut->addHTML("</small></td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqsettitle'>");
			$wgOut->addHTML("<th>To Sets</th>");
			$wgOut->addHTML("<th>Difference</th>");
		$wgOut->addHTML("</tr>");

		$count = 0;

		foreach ($this->comparesets as $index => $compareset) {
			$this->outputSetDifference($compareset, $count);
			$count++;
		}

		$wgOut->addHTML("</table>");

		$wgOut->addHTML("<p><b>Legend</b><ul>");
			$wgOut->addHTML("<li>". $this->formatValueDifference("Stat:", +1) ." -- The given set has more of the displayed stat.</li>");
			$wgOut->addHTML("<li>". $this->formatValueDifference("Stat:", -1) ." -- The given set has less of that stat.</li>");
		$wgOut->addHTML("</ul>");	
	}

	private function outputSetDifference ($compareset, $index) {
		global $wgOut, $skills, $item_types;
		$lf = " \n";

		$wgOut->addHTML("<tr class='". (($index % 2) ? "eqsetodd" : "eqseteven")  ."'>");
			$wgOut->addHTML("<td><a href='". $this->FORM_TARGET ."?id=". $compareset->setid ."'><b>". $compareset->setname ."</b></a></td>");
			$wgOut->addHTML("<td>");

			$result  = $this->formatStatDifference($compareset, "purity", "Purity:", $lf);
			$result .= $this->formatStatDifference($compareset, "ac", "AC:", $lf);
			$result .= $this->formatStatDifference($compareset, "astr", "STR:", $lf);
			$result .= $this->formatStatDifference($compareset, "asta", "STA:", $lf);
			$result .= $this->formatStatDifference($compareset, "adex", "DEX:", $lf);
			$result .= $this->formatStatDifference($compareset, "aagi", "AGI:", $lf);
			$result .= $this->formatStatDifference($compareset, "awis", "WIS:", $lf);
			$result .= $this->formatStatDifference($compareset, "aint", "INT:", $lf);
			$result .= $this->formatStatDifference($compareset, "acha", "CHA:", $lf);
			$result .= $this->formatStatDifference($compareset, "hp", "HP:", $lf);
			$result .= $this->formatStatDifference($compareset, "mana", "MANA:", $lf);
			$result .= $this->formatStatDifference($compareset, "endur", "END:", $lf);
			$wgOut->addHTML($result);

			$result  = $this->formatStatDifference($compareset, "pr", "SV POISON:", $lf);
			$result .= $this->formatStatDifference($compareset, "mr", "SV MAGIC:", $lf);
			$result .= $this->formatStatDifference($compareset, "dr", "SV DISEASE:", $lf);
			$result .= $this->formatStatDifference($compareset, "fr", "SV FIRE:", $lf);
			$result .= $this->formatStatDifference($compareset, "cr", "SV COLD:", $lf);
			$result .= $this->formatStatDifference($compareset, "svcorruption", "SV CORRUPTION:", $lf);
			$wgOut->addHTML($result);

			$result  = $this->formatStatDifference($compareset, "regen", "Regen:", $lf);
			$result .= $this->formatStatDifference($compareset, "manaregen", "Mana Regen:", $lf);
			$result .= $this->formatStatDifference($compareset, "enduranceregen", "End Regen:", $lf);
			$result .= $this->formatStatDifference($compareset, "accuracy", "Accuracy:", "%".$lf);
			$result .= $this->formatStatDifference($compareset, "attack", "Attack:", $lf);
			$result .= $this->formatStatDifference($compareset, "avoidance", "Avoidance:", $lf);
			$result .= $this->formatStatDifference($compareset, "combateffects", "Combat Effects:", $lf);
			$result .= $this->formatStatDifference($compareset, "strikethrough", "Strikethrough:", "%".$lf);
			$result .= $this->formatStatDifference($compareset, "damageshield", "Damage Shield:", $lf);
			$result .= $this->formatStatDifference($compareset, "dotshielding", "DoT Shielding:", "%".$lf);
			$result .= $this->formatStatDifference($compareset, "shielding", "Shielding:", "%".$lf);
			$result .= $this->formatStatDifference($compareset, "spellshield", "Spell Shield:", "%".$lf);
			$result .= $this->formatValueDifference("Haste:", $compareset->diff_haste, "%".$lf);

			$wgOut->addHTML($result);

			foreach ($compareset->diff_skills as $skillnumber => $skillvalue) {
				$wgOut->addHTML($this->formatValueDifference(getEqSkillText($skillnumber).":", $skillvalue, "%".$lf));
			}

			foreach ($compareset->diff_bardmods as $bardtype => $skillvalue) {
				$wgOut->addHTML($this->formatValueDifference(getEqItemTypeText($bardtype) . ":", $skillvalue, $lf));
			}

			foreach ($compareset->diff_extradmg as $type => $value) {
				$wgOut->addHTML($this->formatValueDifference(getEqSkillText($type) . " DMG:", $value, $lf));
			}

			$wgOut->addHTML("</td>");
		$wgOut->addHTML("</tr>");
	}

	private function formatStatDifference ($set, $field, $title, $lf=" ") {
		return $this->formatValueDifference($title, $set->diff_stats[$field], $lf);
	}

	private function formatValueDifference ($stat, $value, $lf=" ") {
		if ($value < 0) {
			return "<span class='eqsetneg'>". $stat . $value . $lf ."</span>";
		}
		else if ($value > 0) {
			return "<span class='eqsetpos'>" . $stat ."+". $value . $lf ."</span>";
		}

		return "";
	}

	private function computeSetDifferences () {
		global $wgOut;

		foreach ($this->comparesets as $index => $compareset) {
			$compareset->compareSet($this->itemset);
		}
	}

	private function loadCompareSets() {
		global $wgOut;

		$count  = 0;
		$result = false;

		if ($this->form_setid) {
			$this->loadItemSet();
		}
		else if ($this->form_setname) {
			$result = $this->loadItemSetByName(false);
			if (!$result) $wgOut->addHTML("Unknown item set '". $this->form_setname  ."'!");
		}

		if ($result) {
			$this->itemset->loadItemData();
			$this->itemset->computeTotals();
		}

		foreach ($this->form_compareids as $item => $compareid) {
			$id = intval($compareid);
			if ($id <= 0) continue;

			$newset = new eqitemset;

			if ($newset->loadSet($id)) {
				$newset->loadItemData();
				$newset->computeTotals();

				if ($count == 0 && !$this->itemset->isvalid) 
					$this->itemset = $newset;
				else
					$this->comparesets[] = $newset;
			}

			$count++;
		}
	}

	private function outputSetList () {	
		global $wgOut;

		$wgOut->addHTML("Item sets allow you to collect multiple items, view their collective stats, and compare them to other sets.<p>\n");
		$wgOut->addHTML("<form name='itemsetlookup' action='". $this->FORM_TARGET ."' method='get'>\n");
		$wgOut->addHTML("<b>Item Set Lookup</b> <input type='text' size='24' maxlength='64' name='searchtext' value='". $this->form_searchtext ."'/>\n");
		$wgOut->addHTML("</form>\n");

		if ($this->form_searchtext)
			$query = "SELECT SQL_CALC_FOUND_ROWS id, name FROM eqitemsets WHERE name LIKE '%". $this->form_searchtext ."%' ORDER BY name LIMIT ". $this->startrow .",". $this->limitcount;
		else
			$query = "SELECT SQL_CALC_FOUND_ROWS id, name FROM eqitemsets ORDER BY name LIMIT ". $this->startrow .",". $this->limitcount;

		$result = mysql_query($query);

		if (!$result) {
			$wgOut->addHTML("No set names matching the given search text were found!");
			return;
		}

		$countresult = mysql_query("SELECT FOUND_ROWS()");
		$totalrows   = mysql_fetch_row($countresult);
		$rowcount    = mysql_num_rows($result);

		if ($totalrows) 
			$totalrows = $totalrows[0];
		else
			$totalrows = 0;

		$wgOut->addHTML("<br/>Found ". $totalrows ." matches. ");
		outputPageLinks($this->FORM_TARGET, "", $this->form_startrow, $this->limitcount, $rowcount, $totalrows);

		$wgOut->addHTML("<form method='get' action='". $this->FORM_TARGET ."'>");
		$wgOut->addHTML("<input type='hidden' name='action' value='compare' />");
		$wgOut->addHTML("<table border='0' cellpadding='1' cellspacing='0' class=''>");
		$count = 1;
		$displaycount = 1 + $this->startrow;

		while (($row = mysql_fetch_row($result)) && $count < $this->limitcount) {
			$wgOut->addHTML("<tr class='". (($count % 2) ? "eqseteven" : "eqsetodd") ."'>");
				$wgOut->addHTML("<td>". $displaycount . ".</td>");
				$wgOut->addHTML("<td><a href='".$this->FORM_TARGET . "?id=". $row[0] ."'>". $row[1] ."</a></td>");
				$wgOut->addHTML("<td><input type='checkbox' value='". $row[0] ."' name='compare[]' /></td>");
			$wgOut->addHTML("</tr>");			
			$count++;
			$displaycount++;
		}

		$wgOut->addHTML("</form>");
		$wgOut->addHTML("</table><p><br>");

		$wgOut->addHTML("<b>With the Above Selected Sets:</b>");
		$wgOut->addHTML("<ul>");
			$wgOut->addHTML("<li>Compare To Set (Name, ID or leave blank) <input type='text' value='' size='20' name='settext' maxlength='256'/> <input class='searchButton' type='submit' value='Compare'></li>");
		$wgOut->addHTML("</ul>");
	}

	private function outputPageLinks() {
		global $wgOut;

		$wgOut->addHTML("<div style='text-align:right; top: -10px; postion: relative;'>\n");
		$wgOut->addHTML("<a href='".  $this->FORM_TARGET ."'>View All</a> &nbsp;\n");

		$cancreate = $this->checkPermissions("new");
		$canedit   = $this->checkPermissions("edit");
		$canlock   = $this->checkPermissions("lock");
		$candelete = $this->checkPermissions("delete");

		if ($this->form_action != "new" && $cancreate) {
			$wgOut->addHTML("<a href='".  $this->FORM_TARGET ."?action=new'>New</a> &nbsp;\n");
		}

		if ($this->form_action != "edit" && $this->form_action != "new" && $this->itemset->setid) {
			if ($canedit)   $wgOut->addHTML("<a href='".  $this->FORM_TARGET ."?action=edit&id=".   $this->itemset->setid ."'>Edit</a> &nbsp;\n");
			if ($canlock)   $wgOut->addHTML("<a href='".  $this->FORM_TARGET ."?action=lock&id=".   $this->itemset->setid ."'>Lock</a> &nbsp;\n");
			if ($candelete) $wgOut->addHTML("<a href='".  $this->FORM_TARGET ."?action=delete&id=". $this->itemset->setid ."'>Delete</a> &nbsp;\n");
		}
	
		$wgOut->addHTML("</div>\n");
	}

	private function outputSetView () {
		global $wgOut;

		if (!$this->itemset->isvalid) return;

			/* Prepare the set data for display */
		$this->itemset->loadItemData();
		$this->itemset->computeTotals();

		$wgOut->addHTML("<table border='0' cellpadding='2' cellspacing='0' class='wikitable'>");

		$wgOut->addHTML("<tr>");
			$wgOut->addHTML("<td class='eqsettitle' colspan='10'><b>Displaying Item Set:</b> <font size='4'><b>". $this->itemset->setname ."</b></font></td>");
		$wgOut->addHTML("</tr>");

		foreach ($this->itemset->setitems as $index => $setitem) {
			$this->outputSetItem($index, $setitem);
		}

		$wgOut->addHTML("<tr>");
			$wgOut->addHTML("<td class='eqsettitle' colspan='10'><b>Total Stats</b></td>");
		$wgOut->addHTML("</tr>");

		$this->outputSetItemTotals();

		$wgOut->addHTML("</table>");
	}

	private function outputSetItemTotals() {
		global $wgOut, $sum_itemset_fields, $skills;

		$overallstats    = $this->itemset->getStatSummary(" ");
		$overallheroic   = $this->itemset->getHeroicSummary(" ");
		$overallresists  = $this->itemset->getResistSummary(" ");
		$overallmods     = $this->itemset->getModSummary(" ");
		$overallskills   = $this->itemset->getSkillSummary(" ");
		$overallbardmods = $this->itemset->getBardModSummary(" ");
		$overallextradmg = $this->itemset->getExtraDmgSummary(" ");

		$wgOut->addHTML("<tr class='eqsetodd'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Stats</td>");
			$wgOut->addHTML("<td>".$overallstats."</td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqseteven'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Heroics</td>");
			$wgOut->addHTML("<td>".$overallheroic."</td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqsetodd'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Resists</td>");
			$wgOut->addHTML("<td>".$overallresists."</td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqseteven'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Mods</td>");
			$wgOut->addHTML("<td>".$overallmods."</td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqsetodd'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Skills</td>");
			$wgOut->addHTML("<td>".$overallskills."</td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqseteven'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Bard Mods</td>");
			$wgOut->addHTML("<td>".$overallbardmods."</td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("<tr class='eqsetodd'>");
			$wgOut->addHTML("<td class='eqfindtitle'>Overall Extra Dmg</td>");
			$wgOut->addHTML("<td>".$overallextradmg."</td>");
		$wgOut->addHTML("</tr>");
		$index = 1;

		foreach ($sum_itemset_fields as $field => $title) {
			$value = $this->itemset->total_stats[$field];
			if (!$value) continue;

			$wgOut->addHTML("<tr class='". (($index % 2) ? 'eqseteven' : 'eqsetodd') ."'>");
				$wgOut->addHTML("<td class='eqfindtitle'>".$title."</td>");
				$wgOut->addHTML("<td>".$value."</td>");
			$wgOut->addHTML("</tr>");
			++$index;
		}

		$wgOut->addHTML("<tr>");
			$wgOut->addHTML("<td class='eqsettitle' colspan='10' class=''><b>Skills</b></td>");
		$wgOut->addHTML("</tr>");
		$index = 1;

		foreach ($this->itemset->total_skills as $skillnumber => $skillvalue) {

			if (isset($skills[$skillnumber])) 
				$skilltext = $skills[$skillnumber];
			else
				$skilltext = $skillnumber;

			$wgOut->addHTML("<tr class='". (($index % 2) ? 'eqsetodd' : 'eqseteven') ."'>");
				$wgOut->addHTML("<td class='eqfindtitle'>".$skilltext."</td>");
				$wgOut->addHTML("<td>".$skillvalue."</td>");
			$wgOut->addHTML("</tr>");

			++$index;
		}
	}

	private function outputSetItem ($index, $setitem) {
		global $wgOut, $sum_itemset_fields;

		if (!$setitem) return false;

		if (!$setitem->item) {
			$wgOut->addHTML("<tr><td>Unknown item #". $setitem->itemid ."</td><td>&nbsp;</td></tr>");
			return false;
		}

		$wgOut->addHTML("<tr class='". (($index % 2) ? 'eqsetodd' : 'eqseteven') ."'>");
			$wgOut->addHTML("<td><a href='/wiki/Special:ShowItem?id=".$setitem->item->getID()."'>". $setitem->item->getName() ."</td>");
			$wgOut->addHTML("<td><small>". $setitem->item->getShortDisplayString("\n") ."</small></td>");
		$wgOut->addHTML("</tr>");

		return true;
	}

	private function addItemsToSet () {
		global $wgOut;

		if (!$this->form_setname) {
			$wgOut->addHTML("No item set specified!");
			return false;
		}

		$setname = $this->form_setname;
		$result  = null;

		if (!$this->form_createnew) {
			if (is_numeric($setname)) $result = $this->itemset->loadSet(intval($setname));
			if (!$result) $result = $this->itemset->loadSetByName($setname);
		}
		
			/* Create new if all else fails */
		if (!$result) {
			if (!$this->form_createexists && !$this->form_createnew) {
				$wgOut->addHTML("Unknown or invalid item set '". $setname ."' specified!");
				return;
			}

			$this->itemset->setname = $setname;
			$this->itemset->setid   = null;
		}

		$itemids = $_REQUEST["itemid"];
		if (!$itemids) $itemids = array();

		foreach ($itemids as $index => $itemid) {
			$itemid = $itemids[$index];
			if ($itemid) $this->itemset->setitems[] = createSetItem(null, $itemid, $this->itemset->setid);
		}

			/* Save new items to the database */
		$result = $this->itemset->saveSet();
	
		return true;
	}

	private function saveItemSet () {
		global $wgOut;

		$setname    = $this->getFormQuery("name");
		//$setitems   = $this->getFormArray("item");
		//$setitemids = $this->getFormArray("itemid");
		$setitems   = $_REQUEST["item"];
		$setitemids = $_REQUEST["itemid"];

		$this->itemset->setFromRequest($this->form_setid, $setname, $setitems, $setitemids);

		$result = $this->itemset->saveSet();
		if (!$result) $wgOut->addHTML("Failed to update the item set record!");

		if (!$this->form_setid) $this->form_setid = $this->itemset->setid;
	}

	private function deleteItemSet () {

		if (!$this->checkPermissions("delete")) return false;

		return $this->itemset->deleteSet();
		
	}

	private function outputErrorMessage ($msg) {
		global $wgOut;
		$wgOut->addHTML($msg);
	}

	private function loadItemSet () {
		global $wgOut;

		$result = $this->itemset->loadSet($this->form_setid);

		if (!$result) {
			$wgOut->addHTML("Failed to load the specified item set!");
			return false;
		}

		return true;
	}

	private function loadItemSetByName ($createnew) {

		if (!$this->form_setname) return false;

		$setname = $this->form_setname;
		$result  = false;

		if (!$createnew) {
			if (is_numeric($setname)) $result = $this->itemset->loadSet(intval($setname));
			if (!$result) $result = $this->itemset->loadSetByName($setname);
		}

		return $result;
	}

	private function outputEditForm () {
		global $wgUser, $wgRequest, $wgOut;

		if (!$this->itemset->isvalid) {
			$wgOut->addHTML("Unknown item set specified!");
			return;
		}
		
		$wgOut->addHTML("<form target='". $FORM_TARGET ."' method='POST'>");
		$wgOut->addHTML("<input type='hidden' name='oldaction' value='". $this->form_action ."' />");
		if ($this->itemset->setid) $wgOut->addHTML("<input type='hidden' name='id' value='". $this->itemset->setid ."' />");
		$wgOut->addHTML("<table border='0' cellpadding='1' cellspacing='1'>");

		$wgOut->addHTML("<tr>");
			$wgOut->addHTML("<td class='eqfindtitle'>Set Name</td>");
			$wgOut->addHTML("<td colspan='4' class='eqfindvalue'><input name='name' type='text' size='40' maxlength='256' value='". $this->itemset->setname ."' /></td>");
		$wgOut->addHTML("</tr>");

		$count = 1;

		for ($c = 0; $c < count($this->itemset->setitems); $c += 2) {
			$setitem = $this->itemset->setitems[$c];
			
			$wgOut->addHTML("<tr>");
				$wgOut->addHTML("<td align='right'>". $$count  .": Item ID</td>");
				$wgOut->addHTML("<td align='left'>");
				$wgOut->addHTML("<input type='text' name='item[]' size='8' maxlength='24' value='". $setitem->itemid ."' />");
				$wgOut->addHTML("<input type='hidden' name='itemid[]' value='". $setitem->id ."' />");
				$wgOut->addHTML("</td>\n");
				$wgOut->addHTML("<td width='16'> </td>");

			$setitem = $this->itemset->setitems[$c+1];
				$wgOut->addHTML("<td align='right'>". ($$count +1) .": Item ID</td>");
				$wgOut->addHTML("<td align='left'>");
				$wgOut->addHTML("<input type='text' name='item[]' size='8' maxlength='24' value='". $setitem->itemid ."' />");
				$wgOut->addHTML("<input type='hidden' name='itemid[]' value='". $setitem->id ."' />");
				$wgOut->addHTML("</td>\n");

			$wgOut->addHTML("</tr>");
			$count += 2;
		}

		for ($c = 0; $c < 10 && $c+$count <= $this->itemset->MAX_ITEMCOUNT+1; $c++) {
			$wgOut->addHTML("<tr>");
				$wgOut->addHTML("<td align='right'>". $$count  .": Item ID</td>");
				$wgOut->addHTML("<td align='left'><input type='text' name='item[]' size='8' maxlength='24' value='' />");
				$wgOut->addHTML("<input type='hidden' name='itemid[]' value='' /></td>");
				$wgOut->addHTML("<td width='16'> </td>");
				$wgOut->addHTML("<td align='right'>". ($$count +1) .": Item ID</td>");
				$wgOut->addHTML("<td align='left'><input type='text' name='item[]' size='8' maxlength='24' value='' />");
				$wgOut->addHTML("<input type='hidden' name='itemid[]' value='' /></td>\n");
			$wgOut->addHTML("</tr>");

			$count += 2;
		}

		
		$wgOut->addHTML("<tr>");
			$wgOut->addHTML("<td colspan='10' align='right'><input type='hidden' name='action' value='update' />");
			$wgOut->addHTML("<input class='bold' type='submit' value='Save' /></td>");
		$wgOut->addHTML("</tr>");

		$wgOut->addHTML("</table>");
		$wgOut->addHTML("</form>");
	}

	private function getQueryString ($name) {
		if (isset($_REQUEST[$name])) return mysql_real_escape_string($_REQUEST[$name]);
		return null;
	}

	private function getQueryInteger ($name) {
		$value = $this->getQueryString($name);
		if (!$value) return ($value);
		if (is_numeric($value)) return intval($value);
		return null;
	}


	private function getFormQuery($name) {
		if (isset($_REQUEST[$name])) return mysql_real_escape_string($_REQUEST[$name]);
		return null;
	}

	private function getFormArray($name) {
		if (isset($_REQUEST[$name])) return $_REQUEST[$name];
		return null;
	}

	private function parseQuery () {
		$this->form_setid = $this->getQueryString("id");
		if ($this->form_setid) $this->form_setid = intval($this->form_setid);

		$this->form_action       = $this->getQueryString("action");
		$this->form_oldaction    = $this->getQueryString("oldaction");
		$this->form_setname      = $this->getQueryString("settext");
		$this->form_searchtext   = $this->getQueryString("searchtext");
		$this->form_startrow     = $this->getQueryInteger("startrow");
		$this->form_createexists = $this->getQueryInteger("createexists");
		$this->form_createnew    = $this->getQueryInteger("createnew");

		$this->form_compareids   = $_REQUEST["compare"];
		if (!$this->form_compareids) $this->form_compareids = array();

		if ($this->form_startrow) $this->startrow = $this->form_startrow;
	}

}

?>


